static const char *RcsId     = "";
static const char *TagName   = "";
static const char *HttpServer= "";
//+=============================================================================
//
// file :        PiMercuryClass.cpp
//
// description : C++ source for the PiMercuryClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the PiMercury once per process.
//
// project :     TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.10 $
//
// $Log: PiMercuryClass.cpp,v $
// Revision 1.10  2017-05-16 13:54:34  graziano
// tango 9
//
// Revision 1.8  2016-08-23 12:06:21  graziano
// changed ChannelXOut to Out0X and added In01 ... In04
//
// Revision 1.7  2015-08-24 09:38:45  graziano
// added Out01 - Out04 attributes
//
// Revision 1.6  2013-10-11 10:13:05  graziano
// Device_4Impl
//
// Revision 1.5  2013-07-09 08:08:33  graziano
// added command LoadConfig
//
// Revision 1.3  2009/04/23 09:07:02  graziano
// development of rt_mode using kernel module
//
// Revision 1.2  2009/04/14 12:40:26  graziano
// added rt_mode, scan mode, ...
//
// Revision 1.1  2008/11/19 10:28:46  graziano
// first version
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <PiMercury.h>
#include <PiMercuryClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create PiMercuryClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_PiMercury_class(const char *name) {
		return PiMercury_ns::PiMercuryClass::init(name);
	}
}


namespace PiMercury_ns
{
//+----------------------------------------------------------------------------
//
// method : 		StartScanClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StartScanClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StartScanClass::execute(): arrived" << endl;

	const Tango::DevVarDoubleArray	*argin;
	extract(in_any, argin);

	((static_cast<PiMercury *>(device))->start_scan(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		CheckTriggerClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *CheckTriggerClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "CheckTriggerClass::execute(): arrived" << endl;

	return insert((static_cast<PiMercury *>(device))->check_trigger());
}

//+----------------------------------------------------------------------------
//
// method : 		GetPositionClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetPositionClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetPositionClass::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<PiMercury *>(device))->get_position(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		LimitSwitchLevelCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LimitSwitchLevelCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LimitSwitchLevelCmd::execute(): arrived" << endl;

	Tango::DevBoolean	argin;
	extract(in_any, argin);

	((static_cast<PiMercury *>(device))->limit_switch_level(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		FindEdgeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *FindEdgeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "FindEdgeClass::execute(): arrived" << endl;

	Tango::DevLong	argin;
	extract(in_any, argin);

	((static_cast<PiMercury *>(device))->find_edge(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LimitSwitchEnableCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LimitSwitchEnableCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LimitSwitchEnableCmd::execute(): arrived" << endl;

	Tango::DevBoolean	argin;
	extract(in_any, argin);

	((static_cast<PiMercury *>(device))->limit_switch_enable(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SetHomeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetHomeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetHomeClass::execute(): arrived" << endl;

	((static_cast<PiMercury *>(device))->set_home());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorOFFClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorOFFClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorOFFClass::execute(): arrived" << endl;

	((static_cast<PiMercury *>(device))->motor_off());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorONClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorONClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorONClass::execute(): arrived" << endl;

	((static_cast<PiMercury *>(device))->motor_on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetVersionClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetVersionClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetVersionClass::execute(): arrived" << endl;

	return insert((static_cast<PiMercury *>(device))->get_version());
}

//+----------------------------------------------------------------------------
//
// method : 		GoHomeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GoHomeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GoHomeClass::execute(): arrived" << endl;

	((static_cast<PiMercury *>(device))->go_home());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		BrakeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *BrakeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "BrakeClass::execute(): arrived" << endl;

	Tango::DevBoolean	argin;
	extract(in_any, argin);

	((static_cast<PiMercury *>(device))->brake(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AbortClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AbortClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AbortClass::execute(): arrived" << endl;

	((static_cast<PiMercury *>(device))->abort());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		StopCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StopCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StopCmd::execute(): arrived" << endl;

	((static_cast<PiMercury *>(device))->stop());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		ForwardClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ForwardClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ForwardClass::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<PiMercury *>(device))->forward(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		BackwardCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *BackwardCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "BackwardCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<PiMercury *>(device))->backward(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LoadConfigClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LoadConfigClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LoadConfigClass::execute(): arrived" << endl;

	((static_cast<PiMercury *>(device))->load_config());
	return new CORBA::Any();
}



//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
PiMercuryClass *PiMercuryClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::PiMercuryClass(string &s)
// 
// description : 	constructor for the PiMercuryClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
PiMercuryClass::PiMercuryClass(string &s):DeviceClass(s)
{

	cout2 << "Entering PiMercuryClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving PiMercuryClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::~PiMercuryClass()
// 
// description : 	destructor for the PiMercuryClass
//
//-----------------------------------------------------------------------------
PiMercuryClass::~PiMercuryClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
PiMercuryClass *PiMercuryClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new PiMercuryClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

PiMercuryClass *PiMercuryClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void PiMercuryClass::command_factory()
{
	command_list.push_back(new ForwardClass("Forward",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"relative movement in user units",
		"",
		Tango::OPERATOR));
	command_list.push_back(new BackwardCmd("Backward",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"relative movement in user units",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StopCmd("Stop",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AbortClass("Abort",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new BrakeClass("Brake",
		Tango::DEV_BOOLEAN, Tango::DEV_VOID,
		"1=Brake ON, 2=Brake OFF",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GoHomeClass("GoHome",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetVersionClass("GetVersion",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorONClass("MotorON",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorOFFClass("MotorOFF",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetHomeClass("SetHome",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LimitSwitchEnableCmd("LimitSwitchEnable",
		Tango::DEV_BOOLEAN, Tango::DEV_VOID,
		"0=OFF 1=ON",
		"",
		Tango::OPERATOR));
	command_list.push_back(new FindEdgeClass("FindEdge",
		Tango::DEV_LONG, Tango::DEV_VOID,
		"direction: 0=start in positive dir, 1= start in negative dir, 2=start in positive dir if reference line is high, 3=start in positive dir if reference line is low",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LimitSwitchLevelCmd("LimitSwitchLevel",
		Tango::DEV_BOOLEAN, Tango::DEV_VOID,
		"0=LOW 1=HIGH",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetPositionClass("GetPosition",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"mode and interval",
		"array of positions",
		Tango::OPERATOR));
	command_list.push_back(new CheckTriggerClass("CheckTrigger",
		Tango::DEV_VOID, Tango::DEV_BOOLEAN,
		"",
		"true=ok",
		Tango::OPERATOR));
	command_list.push_back(new StartScanClass("StartScan",
		Tango::DEVVAR_DOUBLEARRAY, Tango::DEV_VOID,
		"start pos, stop pos, repeat",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LoadConfigClass("LoadConfig",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum PiMercuryClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum PiMercuryClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum PiMercuryClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void PiMercuryClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new PiMercury(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: PiMercuryClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void PiMercuryClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib();
	att_list.push_back(position);

	//	Attribute : Acceleration
	AccelerationAttrib	*acceleration = new AccelerationAttrib();
	att_list.push_back(acceleration);

	//	Attribute : Speed
	SpeedAttrib	*speed = new SpeedAttrib();
	att_list.push_back(speed);

	//	Attribute : TargetPosition
	TargetPositionAttrib	*target_position = new TargetPositionAttrib();
	att_list.push_back(target_position);

	//	Attribute : Error
	ErrorAttrib	*error = new ErrorAttrib();
	att_list.push_back(error);

	//	Attribute : RtMode
	RtModeAttrib	*rt_mode = new RtModeAttrib();
	att_list.push_back(rt_mode);
	
	//	Attribute : Out01
	Out01Attrib	*out_01 = new Out01Attrib();
	att_list.push_back(out_01);

	//	Attribute : Out02
	Out02Attrib	*out_02 = new Out02Attrib();
	att_list.push_back(out_02);

	//	Attribute : Out03
	Out03Attrib	*out_03 = new Out03Attrib();
	att_list.push_back(out_03);

	//	Attribute : Out04
	Out04Attrib	*out_04 = new Out04Attrib();
	att_list.push_back(out_04);

	//	Attribute : In01
	In01Attrib	*in_01 = new In01Attrib();
	att_list.push_back(in_01);

	//	Attribute : In02
	In02Attrib	*in_02 = new In02Attrib();
	att_list.push_back(in_02);

	//	Attribute : In03
	In03Attrib	*in_03 = new In03Attrib();
	att_list.push_back(in_03);

	//	Attribute : In04
	In04Attrib	*in_04 = new In04Attrib();
	att_list.push_back(in_04);

	//	Attribute : ScanSpeed
	ScanSpeedAttrib	*scan_speed = new ScanSpeedAttrib();
	att_list.push_back(scan_speed);

	//	Attribute : Stat
	StatAttrib	*stat = new StatAttrib();
	Tango::UserDefaultAttrProp	stat_prop;
	stat_prop.set_description("bool[0]=Busy\nbool[1]=Command error\nbool[2]=On target\nbool[3]=Index pulse received\nbool[4]=Position limit exceeded\nbool[5]=Excessive position error\nbool[6]=Breakpoint reached\nbool[7]=Motor loop OFF\nbool[9]=Wait in progress\nbool[10]=Command error\nbool[12]=Macro running\nbool[15]=Board addressed\nbool[18]=Move direction polarity\nbool[24]=Limit switch ON\nbool[25]=Limit switch active HIGH\nbool[26]=Find edge operation in progress\nbool[27]=Brake ON\nbool[28]=Joystick ON\nbool[33]=Reference signal (input)\nbool[34]=Positive limit signal (input)\nbool[35]=Negative limit signal (input)\nbool[36]=IO 0\nbool[37]=IO1\nbool[38]=IO 2\nbool[39]=IO 3");
	stat->set_default_properties(stat_prop);
	att_list.push_back(stat);

	//	Attribute : Limits
	LimitsAttrib	*limits = new LimitsAttrib();
	Tango::UserDefaultAttrProp	limits_prop;
	limits_prop.set_description("double[0] = backward limit\ndouble[1] = forward limit");
	limits->set_default_properties(limits_prop);
	att_list.push_back(limits);

	//	Attribute : AxisConfig
	AxisConfigAttrib	*axis_config = new AxisConfigAttrib();
	att_list.push_back(axis_config);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void PiMercuryClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	PiMercuryClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void PiMercuryClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "AxisNumber";
	prop_desc = "Number of the Axis on the motion controller";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisForwardLimit";
	prop_desc = "This is the Motion controller software forward limit\nStops any movement passing that limit";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisBackwardLimit";
	prop_desc = "This is the Motion controller software backward limit\nStops any movement passing that limit";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Serialdevice";
	prop_desc = "the serial device used for communications with Pi Mercury Motion controller";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Serial_timeout";
	prop_desc = "Serial port timeout in ms";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Wr_sleep";
	prop_desc = "Sleep time in ms between serial write of a command and serial read of the response";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Th_sleep";
	prop_desc = "Sleep time in ms between threads";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PositionRatio";
	prop_desc = "the ratio between hardware units and user units";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DefaultMaxSpeed";
	prop_desc = "Max speed (counts/s)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DefaultMinSpeed";
	prop_desc = "Default Min speed (counts/s)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DefaultAcceleration";
	prop_desc = "Default acceleration (counts/s2)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MaxAllowedSpeed";
	prop_desc = "Max allowed speed (counts/s)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RtArraySize";
	prop_desc = "Size of the circular buffer of the real time mode";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ChannelTrigger";
	prop_desc = "Digital input channel used for trigger, values = 1,2,3,4";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Rt_Sleep";
	prop_desc = "Sleep time in ms reading positions in real time mode";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "HomeEdgeOffset";
	prop_desc = "Offset between home position and default edge position.\nThis value is used in the homing procedure (GoHome command)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RTMercurydevice";
	prop_desc = "Device used to communicate with the RT module (/dev/mercury)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RTBufferdevice";
	prop_desc = "Device used to communicate with the rt buffer (/dev/buffer0)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "UseGCS";
	prop_desc = "Use GCS syntax for C-863.11";
	prop_def  = "false";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisConfFile";
	prop_desc = "Configuration file for the axis (only for C-863.11)";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "C_863_10_new";
	prop_desc = "Firmware version C-863.10 > 2.40";
	prop_def  = "false";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ReferenceSwitch";
	prop_desc = "-1: use Reference Switch for homing\n0: no Reference Switch, find edge in positive dir\n1: no Reference Switch, find edge in negative dir";
	prop_def  = "-1";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RemoveEcho";
	prop_desc = "Remove echo from response";
	prop_def  = "false";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		PiMercuryClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void PiMercuryClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Pi Mercury");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Tango Device for Pi Mercury Motion Controller (models C-663, C-862, C-863)");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
